; ++++ Service Enumeration Example ++++
; +++++ Programmed by Luis Costa ++++++
; ++++++++++ Libon,Portugal +++++++++++
; ++++++++ xandaz@hotmail.com +++++++++

.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
FillTreeView    PROTO       :DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\advapi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\advapi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      '???',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Common Control Library initializations ++++

iccx        INITCOMMONCONTROLSEX    <sizeof iccx,ICC_STANDARD_CLASSES+ICC_COOL_CLASSES+ICC_BAR_CLASSES+ICC_LISTVIEW_CLASSES>

; ++++ ListView related ++++

ListViewClass   db     'SysListView32',0
hListView       dd      ?
lvc         LV_COLUMN       <>
lvi         LV_ITEM         <>
szColumn1       db      'Service Display Name',0
szColumn2       db      'Status',0
szColumn3       db      'PID',0

; ++++ TreeView related ++++

TreeViewClass   db      'SysTreeView32',0
hTreeView       dd      ?
tvis            TV_INSERTSTRUCT     <NULL,TVI_FIRST,<>>

; ++++ Menu related ++++

hMenu       dd      ?
hFileMenu   dd      ?
hToolsMenu  dd      ?
hAboutMenu  dd      ?

; ++++ Services related ++++

hSCM                dd      ?
BytesNeeded         dd      ?
ServicesReturned    dd      ?
ResumeHandle        dd      ?
ServiceStates       dd      1
                    db      'Stopped',0
                    dd      2
                    db      'Start Pending',0
                    dd      3
                    db      'Stop Pending',0
                    dd      4
                    db      'Running',0
                    dd      5
                    db      'Cont. Pending',0
                    dd      6
                    db      'Pause Pending',0
                    dd      7
                    db      'Paused',0
                    
; ++++ Mem related ++++

hMem        dd      ?
lpMem       dd      ?
szMem       dd      ?

; ++++ Others ++++

rect        RECT        <>
img1        db          'i.ico',0
img2        db          'si.ico',0
hList       dd        ?
hImg        HBITMAP     ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControlsEx,addr iccx
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
	.elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
			invoke   GetClientRect,hWnd,addr rect
                push    rect.right
                shr     rect.right,2
                dec     rect.right
                invoke  CreateWindowEx,WS_EX_STATICEDGE,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+TVS_LINESATROOT+TVS_HASLINES,\
                            0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                mov     hTreeView,eax
                mov     eax,rect.right
                add     eax,2
                pop     rect.right
                sub     rect.right,eax
                invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD+LVS_REPORT,\
                            eax,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                mov     hListView,eax
                mov     lvc.imask,LVCF_TEXT+LVCF_WIDTH
                shr     rect.right,1
                dec     rect.right
                push    rect.right
                pop     lvc.lx
                mov     lvc.pszText,offset szColumn1
                invoke  SendMessage,hListView,LVM_INSERTCOLUMN,0,addr lvc
                shr     lvc.lx,1
                mov     lvc.pszText,offset szColumn2
                invoke  SendMessage,hListView,LVM_INSERTCOLUMN,1,addr lvc
                mov     lvc.pszText,offset szColumn3
                invoke  SendMessage,hListView,LVM_INSERTCOLUMN,2,addr lvc
                invoke  FillTreeView,hWnd
		.endif	        	
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

FillTreeView    PROC    hWnd:DWORD

    invoke  ImageList_Create,20,20,ILC_COLOR,2,2
    mov     hList,eax
    invoke  LoadImage,hInstance,addr img1,IMAGE_ICON,20,20,LR_LOADFROMFILE
    mov     hImg,eax
    invoke  ImageList_AddIcon,hList,eax
    invoke  DestroyIcon,hImg
    invoke  LoadImage,hInstance,addr img2,IMAGE_ICON,32,32,LR_LOADFROMFILE
    mov     hImg,eax
    invoke  ImageList_AddIcon,hList,eax
    invoke  DestroyIcon,hImg
    invoke  SendMessage,hTreeView,TVM_SETIMAGELIST,TVSIL_NORMAL,hList
    mov     tvis.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE+TVIF_PARAM
    mov     tvis.item.iImage,0
    mov     tvis.item.iSelectedImage,1
    mov     tvis.item.lParam,0
    mov     lvi.imask,LVIF_TEXT
    mov     lvi.iItem,0
    mov     lvi.iSubItem,0
    invoke  OpenSCManager,NULL,NULL,SC_MANAGER_ENUMERATE_SERVICE+GENERIC_READ
    mov     hSCM,eax
    
    
; ++++ invoke with null lpBuff to acknowledge sizeof struct to alloc ++++
    
    invoke  EnumServicesStatus,hSCM,SERVICE_WIN32,SERVICE_ACTIVE+SERVICE_INACTIVE,NULL,\
                NULL,addr BytesNeeded,addr ServicesReturned,addr ResumeHandle
    cmp     BytesNeeded,0
    jne     next_1
    invoke  Beep,200,20
    jmp     end_all                
next_1:
    invoke  LocalAlloc,LPTR,BytesNeeded
    mov     lpMem,eax
    invoke  LocalLock,eax
    mov     lpMem,eax
    push    BytesNeeded
    pop     szMem
    mov     edi,eax
    assume  edi:PTR ENUM_SERVICE_STATUS
    invoke  EnumServicesStatus,hSCM,SERVICE_WIN32,SERVICE_ACTIVE+SERVICE_INACTIVE,\
                lpMem,szMem,addr BytesNeeded,addr ServicesReturned,addr ResumeHandle
    mov     ecx,ServicesReturned
loop_0:                    
    
    push    dword ptr [edi].lpServiceName
    pop     tvis.item.pszText
    push    ecx
    invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
    inc     tvis.item.lParam
    push    [edi].lpDisplayName
    pop     lvi.pszText
    invoke	SendMessage,hListView,LVM_INSERTITEM,NULL,addr lvi
    inc     lvi.iSubItem 
    lea     esi,ServiceStates
do_1:    
    mov     eax,dword ptr [edi].ServiceStatus.dwCurrentState
    cmp     eax,dword ptr [esi]
    je      ins_subitem1
realign_1:    
    lodsb
    or      al,al
    jne     realign_1
    jmp     do_1
ins_subitem1:
    add     esi,4
    mov     lvi.pszText,esi
    invoke  SendMessage,hListView,LVM_SETITEM,0,addr lvi    
    pop     ecx
    dec     ecx
    jcxz    end_all
    inc     lvi.iItem
    mov     lvi.iSubItem,0
    add     edi,sizeof ENUM_SERVICE_STATUS
    jmp     loop_0
end_all:    
    invoke  LocalFree,hMem
    ret    
FillTreeView    endp


end	start